<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  name: 'PartnersShowcase',
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
  },
});
</script>

<template>
  <section class="showcase-wrapper" :class="data.padding && data.padding">
    <SlpContainer>
      <SlpTypography v-if="data.title" tag="h2" variant="heading2-bold">
        {{ data.title }}
      </SlpTypography>
      <SlpRow ref="cards" class="cards">
        <SlpColumn
          v-for="(item, index) in data.items"
          :key="item.title"
          :cols="4"
          class="slp-mb-md-16 card-col showcase-card__container"
        >
          <a
            v-if="data.clickable && item.image"
            :href="item.url.href"
            v-bind="item.ga"
            class="showcase-card__link"
          >
            <div
              class="showcase-card__variant"
              :class="{ 'rounded-corner': index === 2 }"
            >
              <div>
                <img
                  class="slp-mb-24"
                  :src="item.image.src"
                  :alt="item.image.alt"
                  loading="lazy"
                />
                <SlpTypography
                  tag="h3"
                  variant="heading5-bold"
                  class="slp-mb-16"
                >
                  {{ item.title }}
                </SlpTypography>
                <SlpTypography v-if="item.text" tag="p" variant="body1">
                  {{ item.text }}
                </SlpTypography>
              </div>
              <div class="showcase-card__variant--button">
                <SlpTypography tag="span" variant="body1-bold">
                  {{ item.url.text || 'Learn more' }}
                </SlpTypography>
                <SlpIcon
                  name="chevron-lg-right"
                  variant="product"
                  alt="Chevron Right Icon"
                />
              </div>
            </div>
          </a>

          <div
            v-else-if="item.image"
            class="showcase-card__variant"
            :class="{ 'rounded-corner': index === 2 }"
          >
            <img
              class="slp-mb-24"
              :src="item.image.src"
              :alt="item.image.alt"
              loading="lazy"
            />
            <div>
              <SlpTypography tag="h3" variant="heading5-bold" class="slp-mb-16">
                {{ item.title }}
              </SlpTypography>
            </div>
            <div>
              <SlpTypography v-if="item.text" tag="p" variant="body1">
                {{ item.text }}
              </SlpTypography>
            </div>
          </div>
          <div v-else class="showcase-card">
            <SlpIcon
              v-if="item.icon"
              class="slp-mb-16"
              :name="item.icon.name"
              :alt="item.icon.alt"
              :variant="item.icon.variant"
              size="md"
              slp-color="primary-200"
            />
            <div>
              <SlpTypography tag="h3" variant="heading5-bold">
                {{ item.title }}
              </SlpTypography>
            </div>
            <div>
              <SlpTypography v-if="item.text" tag="p" variant="body1">
                {{ item.text }}
              </SlpTypography>
            </div>
          </div>
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </section>
</template>

<style scoped lang="scss">
.showcase-wrapper {
  background: $color-surface-50;

  h2 {
    margin-bottom: $spacing-64;
  }

  .slp-col-md-4 {
    padding-right: $spacing-16;
    padding-bottom: $spacing-16;
  }
}

.icon {
  margin-bottom: $spacing-16;
}

.cards {
  position: relative;
}

.showcase-card {
  display: block;
  background: $color-surface-800;
  height: 260px;
  width: 90%;
  padding: $spacing-24;
  transition: all 0.3s ease-in-out;
  position: relative;
  margin-bottom: $spacing-16;
  border-radius: $border-radius-4;

  h3,
  p,
  a,
  span {
    color: $color-text-300;
  }

  h3 {
    display: block;
    margin-bottom: $spacing-16;
  }

  span {
    display: flex;
    flex: 1 0 auto;
    align-items: center;
    font-weight: $font-weight-bold;
    font-size: $text-body-2-bold;

    svg {
      margin-left: 10px;
    }
  }
}

.showcase-card__link {
  cursor: pointer;
  .showcase-card__variant {
    display: flex;
    flex-direction: column;
    justify-content: space-between;
  }
}

.showcase-card__variant {
  display: block;
  background: $color-surface-800;
  height: 100%;
  width: 350px;
  padding: $spacing-24;
  transition: all 0.3s ease-in-out;
  position: relative;
  margin-bottom: $spacing-16;
  border-radius: $border-radius-4;

  &.rounded-corner {
    border-radius: $spacing-4 $spacing-4 80px $spacing-4 !important;
  }

  &--button {
    border: none;
    color: #171321;
    padding-left: 0;
    -webkit-text-decoration: underline;
    text-decoration: underline;
    text-decoration-color: transparent;
    -webkit-text-decoration: none;
    text-underline-offset: 2px;
    transition: all 0.2s ease-in-out;
    display: flex;
    flex-wrap: nowrap;
    align-items: center;

    .slp-icon {
      margin-left: $spacing-8;
    }
  }

  &:hover &--button {
    text-decoration: underline;
    padding-right: $spacing-8;

    .slp-icon {
      transition: transform 0.2s ease-in-out;
      transform: translateX(4px);
    }
  }

  p,
  a,
  span {
    color: $color-text-300;
  }

  &--button {
    padding: $spacing-16 $spacing-16 $spacing-16 0 !important;
  }
}

@media (max-width: 767px) {
  .showcase-wrapper .slp-col-md-4 {
    padding-right: 0;
  }

  .cards {
    width: 100%;
    flex-wrap: wrap;
    justify-content: center;
    margin-bottom: 0;
    scrollbar-width: none; // hides scrollbar on Firefox
    -ms-overflow-style: none; // hides scrollbar on IE 10+

    &::-webkit-scrollbar {
      // hides scrollbar on browsers that use that use Webkit (Chrome, Safari, Opera, etc)
      width: 0;
      height: 0;
      display: none;
    }
  }

  .showcase-card,
  .showcase-card__variant {
    height: 100%;
    width: 100%;
  }
}
@media (min-width: $breakpoint-md) and (max-width: $breakpoint-lg) {
  .showcase-card__container {
    max-width: 100%;
    width: 25rem;
    margin: 0 auto;
  }
}
</style>
